<?php
/*
Plugin Name: Bbit SEO
Version: 1.0
Plugin URI: http://bbit.vn
Description: The first true all-in-one SEO solution for WordPress, including on-page content analysis, XML sitemaps and much more.
Author: Pham Quang Bao
Author URI: http://bbit.vn
*/

if ( !defined( 'DB_NAME' ) ) {
	header( 'HTTP/1.0 403 Forbidden' );
	die;
}

define( 'WPSEO_PATH', get_template_directory( (__FILE__) ).'/seo/');
define( 'WPSEO_BASENAME', plugin_basename( __FILE__ ) );
define( 'WPSEO_FILE', __FILE__ );
define( 'WPSEO_VERSION', '1.4.25' );

function wpseo_init() {
	require_once( WPSEO_PATH . 'inc/wpseo-functions.php' );
	
	$options = get_wpseo_options();

	if ( isset( $options['stripcategorybase'] ) && $options['stripcategorybase'] )
	require_once( WPSEO_PATH . 'inc/class-rewrite.php' );

	require_once( WPSEO_PATH . 'inc/class-sitemaps.php' );
}

function wpseo_frontend_init() {
	$options = get_wpseo_options();
	require_once( WPSEO_PATH . 'frontend/class-frontend.php' );
	if ( isset( $options['twitter'] ) && $options['twitter'] )
		require_once( WPSEO_PATH . 'frontend/class-twitter.php' );
	if ( isset( $options['opengraph'] ) && $options['opengraph'] )
		require_once( WPSEO_PATH . 'frontend/class-opengraph.php' );
}

function wpseo_admin_init() {
	$options = get_wpseo_options();

	require_once( WPSEO_PATH . 'admin/class-admin.php' );

	global $pagenow;
	if ( in_array( $pagenow, array( 'edit.php', 'post.php', 'post-new.php' ) ) ) {
		require_once( WPSEO_PATH . 'admin/class-metabox.php' );
		if ( isset( $options['opengraph'] ) && $options['opengraph'] )
			require_once( WPSEO_PATH . 'admin/class-opengraph-admin.php' );
	}

	if ( in_array( $pagenow, array( 'edit-tags.php' ) ) )
		require_once( WPSEO_PATH . 'admin/class-taxonomy.php' );

	if ( in_array( $pagenow, array( 'admin.php' ) ) )
		require_once( WPSEO_PATH . 'admin/class-config.php' );

		require_once( WPSEO_PATH . 'admin/class-sitemaps-admin.php' );
}

add_action( 'after_setup_theme', 'wpseo_init', 14 );

if ( !defined( 'DOING_AJAX' ) || !DOING_AJAX )
	require_once( WPSEO_PATH . 'inc/wpseo-non-ajax-functions.php' );

if ( is_admin() ) {
	if ( defined( 'DOING_AJAX' ) && DOING_AJAX ) {
		require_once( WPSEO_PATH . 'admin/ajax.php' );
	} else {
		add_action( 'after_setup_theme', 'wpseo_admin_init', 15 );
	}

	register_activation_hook( __FILE__, 'wpseo_activate' );
	register_deactivation_hook( __FILE__, 'wpseo_deactivate' );
} else {
	add_action( 'after_setup_theme', 'wpseo_frontend_init', 15 );
}
unset( $options );